-- #####################################################################
--  KAP3: Demo 1 - Berechnung Summen Prod, ProdGruppe, Gesamt - klassisch
-- #####################################################################

SELECT  null AS PRDGRP_BEZ,
        null AS PRODUKT_BEZ, 
        SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
FROM  TBL_BESTELLUNG_POS bp
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR

UNION ALL

SELECT  cast(pg.PRODUKT_GRUPPE_NR as VARCHAR)+' - '+pg.BEZEICHNUNG AS PRDGRP_BEZ, 
        null AS PRODUKT_BEZ,
        SUM(bp.ANZAHL*p.PREIS)
FROM  TBL_BESTELLUNG_POS bp
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
  JOIN TBL_PRODUKTGRUPPE pg ON p.PRODUKT_GRUPPE_NR=pg.PRODUKT_GRUPPE_NR  
GROUP BY pg.BEZEICHNUNG, pg.PRODUKT_GRUPPE_NR

UNION ALL

SELECT  cast(pg.PRODUKT_GRUPPE_NR AS VARCHAR)+' - '+pg.BEZEICHNUNG AS PRDGRP_BEZ, 
        cast(p.PRODUKT_NR AS VARCHAR)+' - '+p.BEZEICHNUNG AS PRODUKT_BEZ, 
        SUM(bp.ANZAHL*p.PREIS)
FROM  TBL_BESTELLUNG_POS bp
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
  JOIN TBL_PRODUKTGRUPPE pg ON p.PRODUKT_GRUPPE_NR=pg.PRODUKT_GRUPPE_NR    
GROUP BY p.PRODUKT_NR, p.BEZEICHNUNG, pg.PRODUKT_GRUPPE_NR, pg.BEZEICHNUNG
;

-- #####################################################################
--  KAP3: Demo 2  - Berechnung Summen Prod, ProdGruppe, Gesamt - ROLLUP
-- #####################################################################

SELECT  cast(pg.PRODUKT_GRUPPE_NR as varchar)+' - '+pg.BEZEICHNUNG AS PRDGRP_BEZ,
               cast(p.PRODUKT_NR as varchar)+' - '+p.BEZEICHNUNG AS PRODUKT_BEZ,
              SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
FROM TBL_BESTELLUNG_POS bp
    JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
    JOIN TBL_PRODUKTGRUPPE pg ON p.PRODUKT_GRUPPE_NR=pg.PRODUKT_GRUPPE_NR
GROUP BY ROLLUP ( cast(pg.PRODUKT_GRUPPE_NR as varchar)+' - '+pg.BEZEICHNUNG,
                                        cast(p.PRODUKT_NR as varchar)+' - '+p.BEZEICHNUNG )
;


-- #####################################################################
--  KAP3: Demo 3 - 
-- #####################################################################

SELECT  cast(pg.PRODUKT_GRUPPE_NR as varchar)+' - '+pg.BEZEICHNUNG AS PRDGRP_BEZ,
               cast(p.PRODUKT_NR as varchar)+' - '+p.BEZEICHNUNG AS PRODUKT_BEZ,
              SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
FROM TBL_BESTELLUNG_POS bp
    JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
    JOIN TBL_PRODUKTGRUPPE pg ON p.PRODUKT_GRUPPE_NR=pg.PRODUKT_GRUPPE_NR
GROUP BY ROLLUP ( (pg.PRODUKT_GRUPPE_NR, pg.BEZEICHNUNG),
                                       ( p.PRODUKT_NR, p.BEZEICHNUNG) );

-- #####################################################################
--  KAP3: Demo 4 - Composite Columns
-- #####################################################################

SELECT  convert(VARCHAR(6), BESTELL_DATUM,112) AS MONAT,
        p.PRODUKT_NR,
        p.BEZEICHNUNG AS PRODUKT_BEZ,
        SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
FROM TBL_BESTELLUNG b
   JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLuNG_NR=bp.BESTELLUNG_NR
   JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
WHERE p.PRODUKT_NR IN(1,2)
AND convert(VARCHAR(6), BESTELL_DATUM,112) IN('201301', '201302')
GROUP BY ROLLUP(convert(VARCHAR(6), BESTELL_DATUM,112), (p.PRODUKT_NR, p.BEZEICHNUNG));

-- #####################################################################
--  KAP3: Demo 5 - Beispiel CUBE
-- #####################################################################

SELECT  convert(VARCHAR(6), BESTELL_DATUM,112) AS MONAT,
        p.PRODUKT_NR,
        p.BEZEICHNUNG AS PRODUKT_BEZ,
        SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
FROM TBL_BESTELLUNG b
   JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLuNG_NR=bp.BESTELLUNG_NR
   JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
WHERE p.PRODUKT_NR IN(1,2)
AND convert(VARCHAR(6), BESTELL_DATUM,112) IN('201301', '201302')
GROUP BY CUBE(convert(VARCHAR(6), BESTELL_DATUM,112), (p.PRODUKT_NR, p.BEZEICHNUNG));

-- #####################################################################
--  KAP3: Demo 6 - Beispiel GROUPING()
-- #####################################################################

SELECT  convert(VARCHAR(6), BESTELL_DATUM,112) AS MONAT,
        p.PRODUKT_NR,
        p.BEZEICHNUNG AS PRODUKT_BEZ,
        SUM(bp.ANZAHL*p.PREIS) AS UMSATZ,
        GROUPING(convert(VARCHAR(6), BESTELL_DATUM,112) ) AS GRP_MON,
        GROUPING(p.PRODUKT_NR) AS GRP_PRD
FROM TBL_BESTELLUNG b
   JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLuNG_NR=bp.BESTELLUNG_NR
   JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
WHERE p.PRODUKT_NR IN(1,2)
AND convert(VARCHAR(6), BESTELL_DATUM,112) IN('201301', '201302')
GROUP BY ROLLUP(convert(VARCHAR(6), BESTELL_DATUM,112), (p.PRODUKT_NR, p.BEZEICHNUNG));

-- #####################################################################
--  KAP3: Demo 7 - Beispiel GROUPING_ID()
-- #####################################################################

SELECT  convert(VARCHAR(6), BESTELL_DATUM,112) AS MONAT,
        p.PRODUKT_NR,
        p.BEZEICHNUNG AS PRODUKT_BEZ,
        SUM(bp.ANZAHL*p.PREIS) AS UMSATZ,
        GROUPING_ID(convert(VARCHAR(6), BESTELL_DATUM,112),p.PRODUKT_NR) AS GRP
FROM TBL_BESTELLUNG b
   JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLuNG_NR=bp.BESTELLUNG_NR
   JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
WHERE p.PRODUKT_NR IN(1,2)
AND convert(VARCHAR(6), BESTELL_DATUM,112) IN('201301', '201302')
GROUP BY ROLLUP(convert(VARCHAR(6), BESTELL_DATUM,112), (p.PRODUKT_NR, p.BEZEICHNUNG));

-- #####################################################################
--  KAP3: Demo 8 - Beispiel GROUPING SETS
-- #####################################################################
SELECT convert(VARCHAR(6), BESTELL_DATUM,112) AS MONAT, 
       p.PRODUKT_NR, p.BEZEICHNUNG AS PRODUKT_BEZ, 
       pg.PRODUKT_GRUPPE_NR, pg.BEZEICHNUNG AS PRDGRP_BEZ, 
       SUM(bp.ANZAHL*p.PREIS) AS UMSATZ 
FROM TBL_BESTELLUNG b 
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLuNG_NR=bp.BESTELLUNG_NR 
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR 
  JOIN TBL_PRODUKTGRUPPE pg ON p.PRODUKT_GRUPPE_NR=pg.PRODUKT_GRUPPE_NR 
WHERE p.PRODUKT_NR IN(1,2,3) 
AND convert(VARCHAR(6), BESTELL_DATUM,112) IN('201301', '201302') 
GROUP BY GROUPING SETS ( convert(VARCHAR(6), BESTELL_DATUM,112), 
                       (convert(VARCHAR(6), BESTELL_DATUM,112), p.PRODUKT_NR, p.BEZEICHNUNG), 
                       (pg.PRODUKT_GRUPPE_NR, pg.BEZEICHNUNG), () ) ;