-- #####################################################################
--  KAP9: Demo 1 (Seite 51)
-- #####################################################################

CREATE VIEW V_KUNDEN_HAMBURG AS
SELECT *
FROM TBL_KUNDE
WHERE ORT='Hamburg';


SELECT KUNDE_NR, VORNAME, NACHNAME, PLZ, ORT
FROM V_KUNDEN_HAMBURG;

-- #####################################################################
--  KAP9: Demo 2 (Seite 51)
-- #####################################################################

CREATE VIEW V_ANZ_BESTELLUNGEN_KUNDEN_HH AS
SELECT  k.KUNDE_NR, k.VORNAME, k.NACHNAME, 
              Count(distinct b.BESTELLUNG_NR) AS ANZ_BESTELLUNGEN
FROM V_KUNDEN_HAMBURG k
     JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
GROUP BY k.KUNDE_NR, k.VORNAME, k.NACHNAME;


SELECT *
FROM V_ANZ_BESTELLUNGEN_KUNDEN_HH;

-- #####################################################################
--  KAP9: Demo 3 (Seite 51)
-- #####################################################################

DROP VIEW V_ANZ_BESTELLUNGEN_KUNDEN_HH;

-- #####################################################################
--  KAP9: Demo 4 (Seite 52)
-- #####################################################################

GRANT SELECT ON TBL_KUNDE TO TEST2, TEST3;

-- #####################################################################
--  KAP9: Demo 5 (Seite 53)
-- #####################################################################

REVOKE SELECT ON TBL_KUNDE FROM TEST2;

-- #####################################################################
--  KAP9: Demo 6 (Seite 54)
-- #####################################################################

SELECT PRODUKT_NR, BEZEICHNUNG, UMSATZ,
             CASE
                 WHEN UMSATZ<700 THEN 'A'
                 WHEN UMSATZ BETWEEN 700 AND 1000 THEN 'B'
                 ELSE 'C'
             END AS UMSATZ_GRUPPE
FROM V_UMSATZ_PRODUKT
ORDER BY 3 ASC

-- #####################################################################
--  KAP9: Demo 7 (Seite 54)
-- #####################################################################

SELECT x.*,
		CASE 
			WHEN UMSATZ_GRUPPE='A' THEN '0 ... 700'
			WHEN UMSATZ_GRUPPE='B' THEN '>700 ... 1000'
			ELSE '>1000 ... '
		END AS GRUPPE_BEZ 
FROM (
    SELECT PRODUKT_NR, BEZEICHNUNG, UMSATZ,
                 CASE
                     WHEN UMSATZ<700 THEN 'A'
                     WHEN UMSATZ BETWEEN 700 AND 1000 THEN 'B'
                     ELSE 'C'
                 END AS UMSATZ_GRUPPE
    FROM V_UMSATZ_PRODUKT
) x
ORDER BY 3 ASC

-- #####################################################################
--  KAP9: Demo 8 (Seite 54)
-- #####################################################################

SELECT DISTINCT
     grp.PRODUKT_GRUPPE_NR,
     grp.BEZEICHNUNG,
     SUM(ums.UMSATZ) OVER() AS UMSATZ_GESAMT,
     SUM(ums.UMSATZ) OVER(PARTITION BY grp.PRODUKT_GRUPPE_NR) AS UMSATZ_GRUPPE,
     round(SUM(ums.UMSATZ) OVER(PARTITION BY grp.PRODUKT_GRUPPE_NR)
     /SUM(ums.UMSATZ) OVER(),2) AS ANTEIL
FROM V_UMSATZ_PRODUKT ums
      JOIN TBL_PRODUKTGRUPPE grp ON ums.PRODUKT_GRUPPE_NR=grp.PRODUKT_GRUPPE_NR
ORDER BY 1      

-- #####################################################################
--  KAP9: Demo 9 (Seite 54)
-- #####################################################################

SELECT DISTINCT 
    x.*,
    SUM(UMSATZ) OVER(
      ORDER BY MONAT ASC
      ROWS BETWEEN UNBOUNDED PRECEDING AND CURRENT ROW
    ) AS UMSATZ_KUM    
FROM (
    SELECT DISTINCT
        convert(VARCHAR(6),b.BESTELL_DATUM,112) AS MONAT,
        SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY convert(VARCHAR(6),b.BESTELL_DATUM,112)) AS UMSATZ
    FROM TBL_BESTELLUNG b
      JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
      JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
    WHERE convert(VARCHAR(4),b.BESTELL_DATUM,112)='2013'
) x
ORDER BY 1
