-- #####################################################################
--  KAP3: Demo 1 (Seite 11)
-- #####################################################################

CREATE TABLE TBL_KUNDE(
KUNDE_NR    INTEGER NOT NULL,
VORNAME   VARCHAR(25) NOT NULL,
NACHNAME   VARCHAR(25) NOT NULL,
STRASSE VARCHAR(50),
PLZ   VARCHAR(5),
ORT     VARCHAR(20),
GESCHLECHT VARCHAR(1) CHECK (GESCHLECHT IN('M', 'F', 'm', 'f')),
GEBURTSTAG DATETIME DEFAULT CONVERT(DATETIME, '01.01.1900' ,104)
);

-- #####################################################################
--  KAP3: Demo 2 (Seite 12)
-- #####################################################################

SP_RENAME 'TBL_KUNDE', 'TBL_KUNDE2';

-- #####################################################################
--  KAP3: Demo 3 (Seite 12)
-- #####################################################################

DROP TABLE TBL_KUNDE2;

-- #####################################################################
--  KAP3: Demo 4 (Seite 12)
-- #####################################################################

CREATE TABLE TBL_PRODUKTGRUPPE(
PRODUKT_GRUPPE_NR   INTEGER NOT NULL,
BEZEICHNUNG   VARCHAR(25),
CONSTRAINT PK_PRODGRUPPE PRIMARY KEY (PRODUKT_GRUPPE_NR)
);

-- #####################################################################
--  KAP3: Demo 5 (Seite 13)
-- #####################################################################

CREATE TABLE TBL_PRODUKT(
PRODUKT_NR   INTEGER NOT NULL,
BEZEICHNUNG   VARCHAR(25),
PREIS   NUMERIC(10,2),
PRODUKT_GRUPPE_NR   INTEGER NOT NULL,
CONSTRAINT PK_PRODUKT PRIMARY KEY (PRODUKT_NR),
CONSTRAINT FK_PROD_PROD_GRUPPE FOREIGN KEY (PRODUKT_GRUPPE_NR)
REFERENCES TBL_PRODUKTGRUPPE(PRODUKT_GRUPPE_NR)
);

-- #####################################################################
--  KAP3: Demo 6 (Seite 13)
-- #####################################################################

INSERT INTO TBL_PRODUKT VALUES(1, 'Rumpsteak', 20.95, 1);

-- #####################################################################
--  KAP3: Demo 7 (Seite 13)
-- #####################################################################

INSERT INTO TBL_PRODUKTGRUPPE VALUES(1, 'Fleischgerichte');

INSERT INTO TBL_PRODUKT VALUES(1, 'Rumpsteak', 20.95, 1);


-- #####################################################################
--  KAP3: Demo 8 (Seite 14)
-- #####################################################################

ALTER TABLE TBL_PRODUKT NOCHECK CONSTRAINT FK_PROD_PROD_GRUPPE;

-- #####################################################################
--  KAP3: Demo 9 (Seite 14)
-- #####################################################################

ALTER TABLE TBL_PRODUKT CHECK CONSTRAINT FK_PROD_PROD_GRUPPE;

-- #####################################################################
--  KAP3: Demo 10 (Seite 14)
-- #####################################################################

ALTER TABLE TBL_KUNDE ADD TEST  VARCHAR(10) DEFAULT 'n/a' NOT NULL;

-- #####################################################################
--  KAP3: Demo 11 (Seite 14)
-- #####################################################################

--> In SQL Server funktioniert das ndern von Spalten nicht, die einen CHECK Constraint haben.
--> Hier muss man dann die neue Spalte anlegen, ggf. die Werte kopieren und dann die alte lschen.
--> In diesem Beispiel haben wir einfach nur die alte Spalte gelscht und die neue angelegt.
--> Zu beachten ist, dass auch das Droppen der Spalte nur funktioniert, wenn der CHECK Constraint vorher
--> entfernt wurde. Der Name des Constraints wird vom System automatisch angelegt und man muss diesen 
--> vorher aus dem Objekt-Exlporer unter dbo.TBL_KUNDE->Constraints raussuchen.

ALTER TABLE TBL_KUNDE DROP CONSTRAINT DF__TBL_KUNDE__TEST__76969D2E;
ALTER TABLE TBL_KUNDE DROP COLUMN TEST;
ALTER TABLE TBL_KUNDE ADD TEST FLOAT DEFAULT '-1';

-- #####################################################################
--  KAP3: Demo 12 (Seite 15)
-- #####################################################################

INSERT INTO TBL_KUNDE 
VALUES (1, 'Horst', 'Huber', 'Karolinenweg 11a', '20357', 'Hamburg', 'M', convert(DATETIME, '01.05.1947', 104), null);

-- #####################################################################
--  KAP3: Demo 13 (Seite 15)
-- #####################################################################

INSERT INTO TBL_KUNDE (KUNDE_NR, VORNAME, NACHNAME)
VALUES (2, 'Erika', 'Schmidt');

INSERT INTO TBL_KUNDE (KUNDE_NR, VORNAME, NACHNAME)
VALUES (3, 'Bert', 'Mller');

-- #####################################################################
--  KAP3: Demo 14 (Seite 16)
-- #####################################################################

UPDATE TBL_KUNDE
SET Strasse='Goethestrasse 5', PLZ='22512', Ort='Hamburg'
WHERE KUNDE_NR=2;

UPDATE TBL_KUNDE
SET Strasse='Schwedenweg 22', PLZ='22123', Ort='Hamburg'
WHERE KUNDE_NR=3;

-- #####################################################################
--  KAP3: Demo 15 (Seite 16)
-- #####################################################################

ALTER TABLE TBL_PRODUKT ADD PREIS_NEU FLOAT;

UPDATE TBL_PRODUKT
SET PREIS_NEU=PREIS*5;

SELECT *
FROM TBL_PRODUKT;

-- #####################################################################
--  KAP3: Demo 16 (Seite 16)
-- #####################################################################

DELETE TBL_KUNDE
WHERE KUNDE_NR=2;

SELECT *
FROM TBL_KUNDE

-- #####################################################################
--  KAP3: Demo 17 (Seite 17)
-- #####################################################################

ALTER TABLE TBL_BESTELLUNG NOCHECK CONSTRAINT FK_BESTELLUNG_KUNDE;

TRUNCATE TABLE TBL_KUNDE; --> funktioniert in SQL SErver nicht. Daher muss die Tabelle DELETEd werden:

DELETE TBL_KUNDE;

ALTER TABLE TBL_BESTELLUNG CHECK CONSTRAINT FK_BESTELLUNG_KUNDE;

SELECT *
FROM TBL_KUNDE;
