-- #####################################################################
--  KAP7: Demo 1 (Seite 39)
-- #####################################################################

SELECT AVG(ANZAHL)
FROM (
SELECT PRODUKT_GRUPPE_NR, Count(PRODUKT_NR) AS ANZAHL
FROM TBL_PRODUKT
GROUP BY PRODUKT_GRUPPE_NR
)

-- #####################################################################
--  KAP7: Demo 2 (Seite 40)
-- #####################################################################

SELECT PRODUKT_GRUPPE_NR AS NR, BEZEICHNUNG AS GRUPPE
FROM TBL_PRODUKTGRUPPE
WHERE PRODUKT_GRUPPE_NR NOT IN (
SELECT DISTINCT PRODUKT_GRUPPE_NR
FROM TBL_PRODUKT
)

-- #####################################################################
--  KAP7: Demo 3 (Seite 40)
-- #####################################################################

SELECT PRODUKT_NR, BEZEICHNUNG, PREIS
FROM TBL_PRODUKT
WHERE PREIS>= (
SELECT AVG(PREIS)
FROM TBL_PRODUKT
)

-- #####################################################################
--  KAP7: Demo 4 (Seite 41)
-- #####################################################################

SELECT  grp.BEZEICHNUNG AS GRUPPE, 
        PRODUKT_NR AS NR, 
        p_main.BEZEICHNUNG AS PRODUKT, 
        PREIS,
        (     SELECT AVG(PREIS)
              FROM TBL_PRODUKT p_sub
              WHERE p_sub.PRODUKT_GRUPPE_NR=p_main.PRODUKT_GRUPPE_NR
        ) AS GRP_AVG
FROM TBL_PRODUKT p_main
  JOIN TBL_PRODUKTGRUPPE grp ON p_main.PRODUKT_GRUPPE_NR=grp.PRODUKT_GRUPPE_NR
WHERE p_main.PREIS>=(
    SELECT AVG(PREIS)
    FROM TBL_PRODUKT p_sub
    WHERE p_sub.PRODUKT_GRUPPE_NR=p_main.PRODUKT_GRUPPE_NR
)


-- #####################################################################
--  KAP7: Demo 5 (Seite 42)
-- #####################################################################

SELECT *
FROM TBL_PRODUKTGRUPPE grp
WHERE NOT EXISTS (
    SELECT 1 
    FROM TBL_PRODUKT prd
    WHERE prd.PRODUKT_GRUPPE_NR=grp.PRODUKT_GRUPPE_NR
)

-- #####################################################################
--  KAP7: Demo 6 (Seite 42)
-- #####################################################################

CREATE TABLE TBL_KUNDE_TEST AS
SELECT *
FROM TBL_KUNDE;

-- #####################################################################
--  KAP7: Demo 7 (Seite 40)
-- #####################################################################

TRUNCATE TABLE TBL_KUNDE_TEST;

INSERT INTO TBL_KUNDE_TEST (KUNDE_NR, VORNAME, NACHNAME)
SELECT KUNDE_NR, VORNAME, NACHNAME
FROM TBL_KUNDE;

COMMIT;

-- #####################################################################
--  KAP7: Demo 8 (Seite 40)
-- #####################################################################

DELETE TBL_KUNDE_TEST
WHERE KUNDE_NR IN(5,6,7);

COMMIT;

INSERT INTO TBL_KUNDE_TEST
SELECT *
FROM TBL_KUNDE kunde_alt
WHERE NOT EXISTS (
SELECT 1 
FROM TBL_KUNDE_TEST kunde_neu 
WHERE kunde_neu.KUNDE_NR=kunde_alt.KUNDE_NR
);

COMMIT;

-- #####################################################################
--  KAP7: Demo 9 (Seite 43)
-- #####################################################################

UPDATE TBL_KUNDE_TEST kunde_neu
SET GESCHLECHT=(
SELECT UPPER(GESCHLECHT)
FROM TBL_KUNDE kunde_alt
WHERE kunde_alt.KUNDE_NR=kunde_neu.KUNDE_NR
);

COMMIT;

-- #####################################################################
--  KAP7: Demo 10 (Seite 44)
-- #####################################################################

CREATE TABLE TBL_PRODUKT_TEST AS
SELECT *
FROM TBL_PRODUKT;

DELETE TBL_PRODUKT_TEST
WHERE PRODUKT_NR NOT IN(
SELECT PRODUKT_NR
FROM TBL_BESTELLUNG_POS
);

COMMIT;

-- #####################################################################
--  KAP7: Demo 11 (Seite 44)
-- #####################################################################

SELECT *
FROM (
     SELECT KUNDE_NR, VORNAME, NACHNAME, GEBURTSTAG
     FROM TBL_KUNDE
     ORDER BY 4 ASC
)
WHERE ROWNUM<=3




