-- #####################################################################
--  KAP5: Demo 1 (Seite 29)
-- #####################################################################

SELECT 
TBL_KUNDE.KUNDE_NR, 
TBL_KUNDE.NACHNAME,
TBL_PRODUKTGRUPPE.PRODUKT_GRUPPE_NR AS PG_NR,
TBL_PRODUKTGRUPPE.BEZEICHNUNG AS PG_BEZ
FROM TBL_KUNDE, TBL_PRODUKTGRUPPE
ORDER BY 1,3;

-- #####################################################################
--  KAP5: Demo 2 (Seite 30)
-- #####################################################################

SELECT *
FROM TBL_PRODUKT prd 
  JOIN TBL_PRODUKTGRUPPE  grp ON prd.PRODUKT_GRUPPE_NR=grp.PRODUKT_GRUPPE_NR
WHERE grp.PRODUKT_GRUPPE_NR IN(1,5);

-- #####################################################################
--  KAP5: Demo 3 (Seite 31)
-- #####################################################################

SELECT grp.BEZEICHNUNG AS GRUPPE, prd.BEZEICHNUNG AS PROD
FROM TBL_PRODUKT prd 
  JOIN TBL_PRODUKTGRUPPE grp ON prd.PRODUKT_GRUPPE_NR=grp.PRODUKT_GRUPPE_NR
WHERE grp.PRODUKT_GRUPPE_NR IN(5,6);

-- #####################################################################
--  KAP5: Demo 4 (Seite 31)
-- #####################################################################

-- Da unter MySQL enablen und disablen von einzelnen Constraints nicht funktioniert, werden
-- hier die Constraints gelöscht und neu erstellt.
ALTER TABLE TBL_PRODUKT DROP FOREIGN KEY FK_PROD_PROD_GRUPPE;

ALTER TABLE TBL_PRODUKTGRUPPE DROP PRIMARY KEY;

INSERT INTO TBL_PRODUKTGRUPPE VALUES (1, 'Testgruppe');

COMMIT;

SELECT *
FROM TBL_PRODUKT prd
  JOIN TBL_PRODUKTGRUPPE grp ON prd.PRODUKT_GRUPPE_NR=grp.PRODUKT_GRUPPE_NR
WHERE grp.PRODUKT_GRUPPE_NR=1;

-- #####################################################################
--  KAP5: Demo 5 (Seite 32)
-- #####################################################################

-- Unter MySQL muss man erst den SAFE Update Mode deaktvieren, damit man Löschen/Ändern kann wenn man auf
-- Nicht-PK-Spalten selektiert.
SET SQL_SAFE_UPDATES=0; 

DELETE FROM TBL_PRODUKTGRUPPE WHERE BEZEICHNUNG='Testgruppe';

COMMIT;

ALTER TABLE TBL_PRODUKTGRUPPE ADD CONSTRAINT PK_PROD_GRUPPE PRIMARY KEY(PRODUKT_GRUPPE_NR);

ALTER TABLE TBL_PRODUKT ADD CONSTRAINT FK_PRODUKT_PROD_GRUPPE FOREIGN KEY(PRODUKT_GRUPPE_NR)
						REFERENCES TBL_PRODUKTGRUPPE(PRODUKT_GRUPPE_NR);

-- Safe Update Mode wieder einschalten
SET SQL_SAFE_UPDATES=1;

-- #####################################################################
--  KAP5: Demo 6 (Seite 32)
-- #####################################################################

SELECT grp.BEZEICHNUNG AS GRUPPE, prd.BEZEICHNUNG AS PROD
FROM TBL_PRODUKTGRUPPE grp
  LEFT JOIN TBL_PRODUKT prd ON grp.PRODUKT_GRUPPE_NR=prd.PRODUKT_GRUPPE_NR
WHERE grp.PRODUKT_GRUPPE_NR IN (5,6)
ORDER BY 1,2;
