-- #####################################################################
--  KAP6: Übung 1
-- #####################################################################

SELECT Count(*)
FROM TBL_MITARBEITER
WHERE TYP='KOCH';

-- #####################################################################
--  KAP6: Übung 2
-- #####################################################################

SELECT AVG(PREIS)
FROM TBL_PRODUKT;

-- #####################################################################
--  KAP6: Übung 3
-- #####################################################################

SELECT  bp.BESTELLUNG_NR,
        SUM(ANZAHL*PREIS)
FROM TBL_BESTELLUNG_POS bp
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
GROUP BY bp.BESTELLUNG_NR
ORDER BY 1;

-- #####################################################################
--  KAP6: Übung 4
-- #####################################################################

SELECT k.ORT, SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
FROM TBL_KUNDE k
  JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
GROUP BY k.ORT
ORDER BY 2 DESC;

-- #####################################################################
--  KAP6: Übung 5
-- #####################################################################

SELECT  pg.PRODUKT_GRUPPE_NR,
        pg.BEZEICHNUNG,
        AVG(p.PREIS)
FROM TBL_PRODUKTGRUPPE pg
  JOIN TBL_PRODUKT p ON pg.PRODUKT_GRUPPE_NR=p.PRODUKT_GRUPPE_NR
GROUP BY  pg.PRODUKT_GRUPPE_NR,
          pg.BEZEICHNUNG
HAVING AVG(p.PREIS)>6;

-- #####################################################################
--  KAP6: Aufgabe 1
-- #####################################################################

SELECT m.MITARBEITER_NR, m.NACHNAME, m.VORNAME, SUM(bp.ANZAHL)
FROM TBL_BESTELLUNG b
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_MITARBEITER m ON b.FAHRER_NR=m.MITARBEITER_NR
  JOIN TBL_PRODUKT p ON p.PRODUKT_NR=bp.PRODUKT_NR
WHERE p.PRODUKT_GRUPPE_NR=2 -- --> Pizzen
GROUP BY m.MITARBEITER_NR, m.NACHNAME, m.VORNAME
ORDER BY 4 DESC;

-- --> Deutlich zu sehen, dass Peter Peters die meisten Pizzen ausgeliefert hat.

-- #####################################################################
--  KAP6: Aufgabe 2
-- #####################################################################

SELECT KUNDE_NR, Count(distinct BESTELLUNG_NR) AS ANZ_BESTELLUNGEN
FROM TBL_BESTELLUNG
WHERE BESTELL_DATUM between STR_TO_Date('01.04.2013', '%d.%m.%Y') and STR_TO_Date('30.06.2013', '%d.%m.%Y')
GROUP BY KUNDE_NR
order by 2 DESC;

-- #####################################################################
--  KAP6: Aufgabe 3
-- #####################################################################

SELECT 	p.PRODUKT_NR,
	p.BEZEICHNUNG,
	SUM(bp.ANZAHL) AS VK_STUECK
FROM TBL_BESTELLUNG b
	JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
	JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
WHERE b.BESTELL_DATUM BETWEEN STR_TO_DATE('01.03.2013','%d.%m.%Y') AND STR_TO_DATE('31.03.2013', '%d.%m.%Y')
GROUP BY p.PRODUKT_NR,
	p.BEZEICHNUNG
ORDER BY 3 ASC;

-- --> Ergebnis aus Abfrage ablesen. Produkt 1 verkauft sich am schlechtesten.
         
-- #####################################################################
--  KAP6: Aufgabe 4
-- #####################################################################

SELECT  pg.PRODUKT_GRUPPE_NR,
        pg.BEZEICHNUNG,
        DATE_FORMAT(b.BESTELL_DATUM,'%m/%Y') AS MONAT,
        SUM(bp.ANZAHL*p.PREIS)
FROM TBL_PRODUKTGRUPPE pg
  JOIN TBL_PRODUKT p ON pg.PRODUKT_GRUPPE_NR=p.PRODUKT_GRUPPE_NR
  JOIN TBL_BESTELLUNG_POS bp ON bp.PRODuKT_NR=p.PRODUKT_NR
  JOIN TBL_BESTELLUNG b ON bp.BESTELLUNG_NR=b.BESTELLUNG_NR
WHERE CAST(DATE_FORMAT(b.BESTELL_DATUM,'%Y%m') AS DECIMAL) BETWEEN 201303 AND 201305
GROUP BY pg.PRODUKT_GRUPPE_NR,
        pg.BEZEICHNUNG,
        DATE_FORMAT(b.BESTELL_DATUM,'%m/%Y') 
ORDER BY 1,3;

-- #####################################################################
--  KAP6: Aufgabe 5
-- #####################################################################

SELECT  p.PRODUKT_NR, 
        p.BEZEICHNUNG,
        SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
FROM TBL_PRODUKT p
  LEFT JOIN TBL_BESTELLUNG_POS bp ON p.PRODUKT_NR=bp.PRODUKT_NR
GROUP BY  p.PRODUKT_NR, 
          p.BEZEICHNUNG
ORDER BY 3 DESC;
          
-- #####################################################################
--  KAP6: Aufgabe 6
-- #####################################################################

SELECT  m.MITARBEITER_NR,
        m.NACHNAME,
        m.VORNAME,
        Count(distinct b.KUNDE_NR) AS ANZ_KUNDEN,
        Count(b.BESTELLUNG_NR) AS ANZ_BEST
FROM TBL_MITARBEITER m
  JOIN TBL_BESTELLUNG b ON m.MITARBEITER_NR=b.FAHRER_NR
GROUP BY  m.MITARBEITER_NR,
        m.NACHNAME,
        m.VORNAME;

-- #####################################################################
--  KAP6: Aufgabe 7
-- #####################################################################

SELECT  k.ORT,
        COUNT(distinct b.BESTELLUNG_NR) AS ANZ_BEST,
        SUM(bp.ANZAHL*p.PREIS) AS UMSATZ,
        ROUND(SUM(bp.ANZAHL*p.PREIS)/COUNT(distinct b.BESTELLUNG_NR),2) AS AVG_UMS_PRO_BEST
FROM TBL_KUNDE k
  JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
GROUP BY k.ORT
ORDER BY 4 DESC;

-- #####################################################################
--  KAP6: Aufgabe 8
-- #####################################################################

SELECT  m.MITARBEITER_NR,
        VORNAME,
        NACHNAME,
        SUM(bp.ANZAHL*p.PREIS) AS UMSATZ,
        SUM(bp.ANZAHL*p.PREIS*m.PROV_SATZ) AS PROVISION
FROM TBL_MITARBEITER m
  LEFT JOIN TBL_BESTELLUNG b ON m.MITARBEITER_NR=b.VERKAEUFER_NR
  LEFT JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  LEFT JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
WHERE TYP='VERKÄUFER'
GROUP BY m.MITARBEITER_NR,
        VORNAME,
        NACHNAME 
ORDER BY 5 DESC;
