-- #####################################################################
--  KAP8: Übung 1
-- #####################################################################

SELECT 'Top', x.*
FROM (
    SELECT  p.PRODUKT_NR,
            p.BEZEICHNUNG,
            SUM(p.PREIS*bp.ANZAHL) AS UMSATZ
    FROM TBL_PRODUKT p
      JOIN TBL_BESTELLUNG_POS bp ON p.PRODUKT_NR=bp.PRODUKT_NR
    GROUP BY p.PRODUKT_NR,p.BEZEICHNUNG
    ORDER BY 3 DESC LIMIT 2
) x


UNION

SELECT 'Flop', x.*
FROM (
    SELECT  p.PRODUKT_NR,
            p.BEZEICHNUNG,
            SUM(p.PREIS*bp.ANZAHL) AS UMSATZ
    FROM TBL_PRODUKT p
      JOIN TBL_BESTELLUNG_POS bp ON p.PRODUKT_NR=bp.PRODUKT_NR
    GROUP BY p.PRODUKT_NR,p.BEZEICHNUNG
    ORDER BY 3 ASC LIMIT 2
) x
ORDER BY 4 DESC;

-- #####################################################################
--  KAP8: Übung 2
-- #####################################################################

-- -->INTERSECT unter MySQL nicht verfügbar.

-- #####################################################################
--  KAP8: Übung 3
-- #####################################################################

-- --> MINUS unter MySQL nicht verfügbar.

-- #####################################################################
--  KAP8: Aufgabe 1 
-- #####################################################################

SELECT *
FROM (
	SELECT  'Hamburg' AS ORT,
            p.PRODUKT_NR,
            p.BEZEICHNUNG,
            SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
	FROM TBL_KUNDE k
		JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
		JOiN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
		JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
	WHERE k.ORT='Hamburg'
	GROUP BY 'Hamburg', p.PRODUKT_NR,p.BEZEICHNUNG
	ORDER BY 4 DESC LIMIT 1
) a 

UNION

SELECT *
FROM (
	SELECT  'Kiel' AS ORT,
            p.PRODUKT_NR,
            p.BEZEICHNUNG,
            SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
	FROM TBL_KUNDE k
		JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
		JOiN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
		JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
	WHERE k.ORT='Kiel'
	GROUP BY 'Kiel', p.PRODUKT_NR,p.BEZEICHNUNG
	ORDER BY 4 DESC LIMIT 1
) b;

-- #####################################################################
--  KAP8: Aufgabe 2 
-- #####################################################################

-- -->INTERSECT unter MySQL nicht verfügbar.

-- #####################################################################
--  KAP8: Aufgabe 3
-- #####################################################################

-- -->MINUS unter MySQL nicht verfügbar.

-- #####################################################################
--  KAP8: Aufgabe 4
-- #####################################################################

SELECT NR, BEZEICHNUNG, UMSATZ
FROM (
    SELECT  p.PRODUKT_GRUPPE_NR*1000+p.PRODUKT_NR AS SORTIERUNG,
            p.PRODUKT_GRUPPE_NR||'-'||p.PRODUKT_NR AS NR,
            p.BEZEICHNUNG,
            SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
    FROM  TBL_BESTELLUNG_POS bp
          JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
    GROUP BY  p.PRODUKT_GRUPPE_NR*1000+p.PRODUKT_NR,
              p.PRODUKT_GRUPPE_NR||'-'||p.PRODUKT_NR,
              p.BEZEICHNUNG
    
    UNION
    
    SELECT  pg.PRODUKT_GRUPPE_NR*1000+999 AS SORTIERUNG,
            CAST(pg.PRODUKT_GRUPPE_NR AS CHAR),
            pg.BEZEICHNUNG,
            SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
    FROM  TBL_BESTELLUNG_POS bp
          JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
          JOIN TBL_PRODUKTGRUPPE pg ON p.PRODUKT_GRUPPE_NR=pg.PRODUKT_GRUPPE_NR
    GROUP BY  pg.PRODUKT_GRUPPE_NR*1000,
              CAST(pg.PRODUKT_GRUPPE_NR AS CHAR),
              pg.BEZEICHNUNG
    
    UNION
    
    SELECT  CAST('10000' AS DECIMAL) AS SORTIERUNG,
            '0',
            'GESAMT',
            SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
    FROM  TBL_BESTELLUNG_POS bp
          JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
    GROUP BY  CAST('10000' AS DECIMAL), '0', 'GESAMT'
) x
ORDER BY SORTIERUNG;

