-- #####################################################################
--  KAP9: Übung 1
-- #####################################################################

CREATE VIEW V_UMSATZ_PRODUKT AS
SELECT  p.PRODUKT_GRUPPE_NR,
        p.PRODUKT_NR,
        p.BEZEICHNUNG,
        p.PREIS,
        SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
FROM TBL_BESTELLUNG_POS bp 
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
GROUP BY p.PRODUKT_GRUPPE_NR,
        p.PRODUKT_NR,
        p.BEZEICHNUNG,
        p.PREIS
ORDER BY 1,2;

-- #####################################################################
--  KAP9: Übung 2
-- #####################################################################

CREATE VIEW V_SEC_KUNDE AS
SELECT KUNDE_NR, VORNAME, NACHNAME
FROM TBL_KUNDE;

GRANT SELECT ON V_SEC_KUNDE TO TEST3;


-- #####################################################################
--  KAP9: Übung 3
-- #####################################################################

SELECT  KUNDE_NR,
        CASE WHEN ANZ_BESTELLUNGEN>5 THEN 'ja' ELSE 'nein' END AS MEHR_ALS_5_BEST
FROM (
    SELECT k.KUNDE_NR, Count(distinct BESTELLUNG_NR) AS ANZ_BESTELLUNGEN
    FROM TBL_KUNDE k
      JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
    GROUP BY k.KUNDE_NR
) x
ORDER BY 1;

-- #####################################################################
--  KAP9: Übung 4 
-- #####################################################################

-- --> Analytische Funktionen unter MySQL nicht verfügbar.

-- #####################################################################
--  KAP9: Übung 5
-- #####################################################################

-- --> Analytische Funktionen unter MySQL nicht verfügbar.


-- #####################################################################
--  KAP9: Aufgabe 1
-- #####################################################################

-- --> Anmelden als Benutzer TEST

REVOKE ALL PRIVILEGES ON TBL_KUNDE FROM PUBLIC;

GRANT UPDATE (PREIS) ON TBL_PRODUKT TO TEST2;

GRANT SELECT ON TBL_PRODUKT TO TEST2;

-- --> Anmelden als Benutzer TEST2 und Test der Rechte

Select *
from TEST.TBL_KUNDE; -- --> Sollte nicht möglich sein.


UPDATE TEST.TBL_PRODUKT
SET PREIS=1.0
WHERE PRODUKT_NR=16;

COMMIT;

Select *
from TEST.TBL_PRODUKT;

-- #####################################################################
--  KAP9: Aufgabe 2
-- #####################################################################

CREATE VIEW V_UMSATZ_GESAMT AS
SELECT SUM(UMSATZ) AS UMSATZ_GESAMT
FROM V_UMSATZ_PRODUKT;

ALTER TABLE TBL_PRODUKT ADD(UMSATZ_PRODUKT NUMERIC(10,2));

UPDATE TBL_PRODUKT p
SET UMSATZ_PRODUKT= (SELECT UMSATZ FROM V_UMSATZ_PRODUKT WHERE PRODUKT_NR=p.PRODUKT_NR);

commit;

ALTER TABLE TBL_PRODUKT ADD(UMSATZ_ANTEIL NUMERIC(10,2));

UPDATE TBL_PRODUKT
SET UMSATZ_ANTEIL=round(UMSATZ_PRODUKT/(SELECT UMSATZ_GESAMT FROM V_UMSATZ_GESAMT),2);

commit;

-- #####################################################################
--  KAP9: Aufgabe 3
-- #####################################################################

-- --> Analytische Funktionen unter MySQL nicht verfügbar.

-- #####################################################################
--  KAP9: Aufgabe 4
-- #####################################################################

-- --> Analytische Funktionen unter MySQL nicht verfügbar.
