-- Rechte mit ADMIN User zuordnen
GRANT CREATE TRIGGER TO TEST;
GRANT CREATE PROCEDURE TO TEST;
GRANT CREATE SEQUENCE TO TEST;

-- Funktionen erstellen und verwenden
DROP FUNCTION NEtto2Brutto;

CREATE OR REPLACE FUNCTION Netto2Brutto(v IN NUMBER) RETURN NUMBER AS
BEGIN
  return(v*1.19);
END;

SELECT Netto2Brutto(SUM(bp.ANZAHL*p.PREIS))
from tbl_Bestellung_pos bp
  join tbl_produkt p on bp.produkt_nr=p.produkt_nr;
  
-- Tabellen fr Trigger Beispiele

CREATE TABLE TBL_TRIGGER_TEST (
  ID NUMBER,
  TEXT VARCHAR2(20)
);

DROP TABLE TBL_TRIGGER_TEST_LOG;

CREATE TABLE TBL_TRIGGER_TEST_LOG (
  ID NUMBER,
  TEXT VARCHAR2(20),
  DELETE_DATE DATE,
  AKTION VARCHAR2(1)
);

TRUNCATE TABLE TBL_TRIGGER_TEST;
INSERT INTO TBL_TRIGGER_TEST VALUES(1,'Hallo');  
INSERT INTO TBL_TRIGGER_TEST VALUES(2,'Hallo Welt!');
INSERT INTO TBL_TRIGGER_TEST VALUES(3,'Test');
INSERT INTO TBL_TRIGGER_TEST VALUES(4,'blafasel');
COMMIT;

-- Beispiel DELETE Trigger

CREATE OR REPLACE TRIGGER trBDelete BEFORE DELETE ON TEST.TBL_TRIGGER_TEST FOR EACH ROW
BEGIN
  INSERT INTO TEST.TBL_TRIGGER_TEST_LOG VALUES(:old.ID, :old.TEXT, sysdate, 'D');
END;

-- Sequence und INSERT Trigger erstellen
DROP SEQUENCE sqID;
CREATE SEQUENCE sqID START WITH 5 INCREMENT BY 1;

CREATE OR REPLACE TRIGGER trBInsert BEFORE INSERT ON TEST.TBL_TRIGGER_TEST FOR EACH ROW
BEGIN
  :new.ID:=sqID.nextVal;
  INSERT INTO TEST.TBL_TRIGGER_TEST_LOG VALUES(:new.ID, :new.TEXT, sysdate, 'I');
END;
