-- #####################################################################
--  KAP2: bung 1
-- #####################################################################

SELECT DISTINCT
    to_char(b.BESTELL_DATUM,'YYYYMM') AS MONAT,
    SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY to_char(b.BESTELL_DATUM,'YYYYMM')) AS UMSATZ
FROM TBL_BESTELLUNG b
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
WHERE to_char(b.BESTELL_DATUM,'YYYY')='2013'
ORDER BY 1;

-- #####################################################################
--  KAP2: bung 2
-- #####################################################################

SELECT DISTINCT
    p.PRODUKT_NR,
    p.BEZEICHNUNG,
    SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY p.PRODUKT_NR) AS UMSATZ,
    SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY p.PRODUKT_GRUPPE_NR) AS UMSATZ_PG,
    round(SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY p.PRODUKT_NR)/
    SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY p.PRODUKT_GRUPPE_NR)*100,1) AS ANTEIL
FROM TBL_BESTELLUNG b
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
WHERE to_char(b.BESTELL_DATUM,'YYYYQ')='20132'
ORDER BY 1;

-- #####################################################################
--  KAP2: bung 3
-- #####################################################################

SELECT DISTINCT
        MONAT,
        MAX(UMSATZ_TAG) OVER(PARTITION BY MONAT) AS MAX_UMSATZ,
        MIN(UMSATZ_TAG) OVER(PARTITION BY MONAT) AS MIN_UMSATZ,        
        UMSATZ_MONAT,
        UMSATZ_QUARTAL,
        ANTEIL
FROM (
    SELECT DISTINCT
        b.BESTELL_DATUM,
        to_char(b.BESTELL_DATUM,'YYYYMM') AS MONAT,
        SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY to_char(b.BESTELL_DATUM,'YYYYMMDD')) AS UMSATZ_TAG,
        SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY to_char(b.BESTELL_DATUM,'YYYYMM')) AS UMSATZ_MONAT,
        SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY to_char(b.BESTELL_DATUM,'YYYYQ')) AS UMSATZ_QUARTAL,
        round(SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY to_char(b.BESTELL_DATUM,'YYYYMM'))/
        SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY to_char(b.BESTELL_DATUM,'YYYYQ'))*100,1) AS ANTEIL
    FROM TBL_BESTELLUNG b
      JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
      JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
    WHERE to_char(b.BESTELL_DATUM,'YYYYQ')='20131'
) umsatz
ORDER BY 1;

-- #####################################################################
--  KAP2: bung 4
-- #####################################################################

SELECT DISTINCT
          MONAT,
          ANZ_BEST,
          SUM(ANZ_BEST) OVER(PARTITION BY substr(MONAT,1,4) 
                             ORDER BY MONAT
                             ROWS BETWEEN UNBOUNDED PRECEDING AND CURRENT ROW
                            ) AS ANZ_BEST_KUM
FROM (          
      SELECT  to_char(b.BESTELL_DATUM,'YYYYMM') AS MONAT,
              COUNT(b.BESTELLUNG_NR) AS ANZ_BEST
      FROM TBL_BESTELLUNG b
      WHERE to_char(b.BESTELL_DATUM,'YYYY')='2013'
      GROUP BY to_char(b.BESTELL_DATUM,'YYYYMM')
) best
ORDER BY 1;

-- #####################################################################
--  KAP2: bung 5
-- #####################################################################

SELECT DISTINCT
        b.BESTELL_DATUM,
        SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY b.BESTELL_DATUM) AS UMSATZ,
        SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY to_char(b.BESTELL_DATUM,'YYYYMM')
                                    ORDER BY b.BESTELL_DATUM
                                    RANGE BETWEEN UNBOUNDED PRECEDING AND CURRENT ROW
                                   ) AS UMSATZ_KUM
FROM TBL_BESTELLUNG b
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
WHERE to_char(b.BESTELL_DATUM,'YYYYMM')='201301'
ORDER BY 1;

-- #####################################################################
--  KAP2: bung 6
-- #####################################################################

SELECT DISTINCT
        MONAT,
        UMSATZ_MONAT,
        MAX(UMSATZ_MONAT) OVER(ORDER BY to_number(MONAT) ASC RANGE BETWEEN 1 PRECEDING AND 1 PRECEDING) AS UMSATZ_VORMONAT,
        UMSATZ_MONAT-MAX(UMSATZ_MONAT) OVER(ORDER BY to_number(MONAT) ASC RANGE BETWEEN 1 PRECEDING AND 1 PRECEDING) AS DIFF_ABS,
        FIRST_VALUE(UMSATZ_TAG) OVER(PARTITION BY MONAT ORDER BY BESTELL_DATUM) AS UMSATZ_1ST_DAY,
        NTH_VALUE(UMSATZ_TAG,15) OVER(PARTITION BY MONAT ORDER BY BESTELL_DATUM ROWS BETWEEN UNBOUNDED PRECEDING AND UNBOUNDED FOLLOWING) AS UMSATZ_15TH_DAY
FROM (
        SELECT DISTINCT
            b.BESTELL_DATUM,
            to_char(b.BESTELL_DATUM,'YYYYMM') AS MONAT,
            SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY to_char(b.BESTELL_DATUM,'YYYYMMDD')) AS UMSATZ_TAG,
            SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY to_char(b.BESTELL_DATUM,'YYYYMM')) AS UMSATZ_MONAT
        FROM TBL_BESTELLUNG b
          JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
          JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
        WHERE to_char(b.BESTELL_DATUM,'YYYYQ')='20131'
) umsatz
ORDER BY 1;

-- #####################################################################
--  KAP2: Aufgabe 1
-- #####################################################################

SELECT DISTINCT
    to_char(b.BESTELL_DATUM,'YYYYQ') AS QUARTAL,
    SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY to_char(b.BESTELL_DATUM,'YYYYQ')) AS UMSATZ,
    COUNT(DISTINCT b.BESTELLUNG_NR) OVER(PARTITION BY to_char(b.BESTELL_DATUM,'YYYYQ')) AS ANZ_BEST
FROM TBL_BESTELLUNG b
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
WHERE to_char(b.BESTELL_DATUM,'YYYY')='2013'
ORDER BY 1;


-- #####################################################################
--  KAP2: Aufgabe 2
-- #####################################################################
SELECT DISTINCT
    b.BESTELL_DATUM,
    SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY b.BESTELL_DATUM) AS UMSATZ,
    SUM(bp.ANZAHL*p.PREIS) OVER(ORDER BY b.BESTELL_DATUM RANGE BETWEEN 1 PRECEDING AND 1 PRECEDING) AS UMSATZ_VORTAG,
    SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY b.BESTELL_DATUM)-
    SUM(bp.ANZAHL*p.PREIS) OVER(ORDER BY b.BESTELL_DATUM RANGE BETWEEN 1 PRECEDING AND 1 PRECEDING) AS ABWEICHUNG
FROM TBL_BESTELLUNG b
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
WHERE to_char(b.BESTELL_DATUM,'YYYYMM')='201302'
ORDER BY 1;


-- #####################################################################
--  KAP2: Aufgabe 3
-- #####################################################################
SELECT *
FROM (
    SELECT DISTINCT
          KUNDE_NR,
          VORNAME,
          NACHNAME,
          UMSATZ,
          PRODUKT,
          RANK() OVER(PARTITION BY KUNDE_NR ORDER BY KUNDE_NR, UMSATZ_KD_PROD DESC) AS PROD_RANG 
    FROM (
          SELECT DISTINCT
                  k.KUNDE_NR,
                  k.VORNAME,
                  k.NACHNAME,
                  SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY k.KUNDE_NR) AS UMSATZ,
                  p.PRODUKT_NR||' - '||p.BEZEICHNUNG AS PRODUKT,
                  SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY k.KUNDE_NR, p.PRODUKT_NR) AS UMSATZ_KD_PROD
          FROM TBL_KUNDE k
            JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
            JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
            JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
          WHERE to_char(b.BESTELL_DATUM,'YYYYMM')='201301'
    ) ums
) kunde
WHERE PROD_RANG=1
ORDER BY 1;

-- #####################################################################
--  KAP2: Aufgabe 4
-- #####################################################################

SELECT DISTINCT
    to_char(b.BESTELL_DATUM,'YYYYMM') AS MONAT,
    SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY to_char(b.BESTELL_DATUM,'YYYYMM')) AS UMSATZ,
    SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY to_char(b.BESTELL_DATUM,'YYYY')
                                ORDER BY to_char(b.BESTELL_DATUM,'YYYYMM')
                                RANGE UNBOUNDED PRECEDING
                               ) AS UMSATZ_KUM,
    SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY to_char(b.BESTELL_DATUM,'YYYY')
                                ORDER BY to_number(to_char(b.BESTELL_DATUM,'YYYYMM'))
                                RANGE BETWEEN 2 PRECEDING AND CURRENT ROW
                               ) AS UMSATZ_LAST_3MON                              
FROM TBL_BESTELLUNG b
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
WHERE to_char(b.BESTELL_DATUM,'YYYY')='2013'
ORDER BY 1;

-- #####################################################################
--  KAP2: Aufgabe 5
-- #####################################################################

SELECT DISTINCT
      PRODUKT_NR,
      BEZEICHNUNG,
      SUM(UMSATZ) OVER(PARTITION BY PRODUKT_NR) AS UMSATZ,
      SUM(UMSATZ) OVER() AS UMSATZ_GES,
      round(SUM(UMSATZ) OVER(PARTITION BY PRODUKT_NR)/SUM(UMSATZ) OVER()*100,1) AS ANTEIL,
      FIRST_VALUE(MONAT) OVER(PARTITION BY PRODUKT_NR ORDER BY PRODUKT_NR, UMSATZ DESC) AS MONAT_MAX,
      FIRST_VALUE(MONAT) OVER(PARTITION BY PRODUKT_NR ORDER BY PRODUKT_NR, UMSATZ ASC) AS MONAT_MIN
FROM (
        SELECT  to_char(b.BESTELL_DATUM,'YYYYMM') AS MONAT,
                p.PRODUKT_NR,
                p.BEZEICHNUNG,
                SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
        FROM TBL_BESTELLUNG b
          JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
          JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
        WHERE to_char(b.BESTELL_DATUM,'YYYY')='2013'
        GROUP BY to_char(b.BESTELL_DATUM,'YYYYMM'),
                p.PRODUKT_NR,
                p.BEZEICHNUNG
) ums
ORDER BY 1;

