-- #####################################################################
--  KAP3: Demo 1 (Seite 11)
-- #####################################################################

CREATE TABLE TBL_KUNDE(
KUNDE_NR    NUMBER(10,0) NOT NULL,
VORNAME   VARCHAR2(25) NOT NULL,
NACHNAME   VARCHAR2(25) NOT NULL,
STRASSE VARCHAR2(50),
PLZ   VARCHAR2(5),
ORT     VARCHAR2(20),
GESCHLECHT VARCHAR2(1) CHECK (GESCHLECHT IN('M', 'F', 'm', 'f')),
GEBURTSTAG DATE DEFAULT TO_DATE('01.01.1900' ,'DD.MM.YYYY')
);

-- #####################################################################
--  KAP3: Demo 2 (Seite 12)
-- #####################################################################

RENAME TBL_KUNDE TO TBL_KUNDE2;

-- #####################################################################
--  KAP3: Demo 3 (Seite 12)
-- #####################################################################

DROP TABLE TBL_KUNDE2;

-- #####################################################################
--  KAP3: Demo 4 (Seite 12)
-- #####################################################################

CREATE TABLE TBL_PRODUKTGRUPPE(
PRODUKT_GRUPPE_NR   NUMBER(5,0) NOT NULL,
BEZEICHNUNG   VARCHAR2(25),
CONSTRAINT PK_PRODGRUPPE PRIMARY KEY (PRODUKT_GRUPPE_NR)
);

-- #####################################################################
--  KAP3: Demo 5 (Seite 13)
-- #####################################################################

CREATE TABLE TBL_PRODUKT(
PRODUKT_NR   NUMBER(5, 0) NOT NULL,
BEZEICHNUNG   VARCHAR2(25),
PREIS   NUMBER(10,2),
PRODUKT_GRUPPE_NR   NUMBER(5, 0) NOT NULL,
CONSTRAINT PK_PRODUKT PRIMARY KEY (PRODUKT_NR),
CONSTRAINT FK_PROD_PROD_GRUPPE FOREIGN KEY (PRODUKT_GRUPPE_NR)
REFERENCES TBL_PRODUKTGRUPPE(PRODUKT_GRUPPE_NR)
);

-- #####################################################################
--  KAP3: Demo 6 (Seite 13)
-- #####################################################################

INSERT INTO TBL_PRODUKT VALUES(1, 'Rumpsteak', 20.95, 1);

COMMIT;

-- #####################################################################
--  KAP3: Demo 7 (Seite 13)
-- #####################################################################

INSERT INTO TBL_PRODUKTGRUPPE VALUES(1, 'Fleischgerichte');
COMMIT;

INSERT INTO TBL_PRODUKT VALUES(1, 'Rumpsteak', 20.95, 1);
COMMIT;

-- #####################################################################
--  KAP3: Demo 8 (Seite 14)
-- #####################################################################

ALTER TABLE TBL_PRODUKT DISABLE CONSTRAINT FK_PROD_PROD_GRUPPE;

-- #####################################################################
--  KAP3: Demo 9 (Seite 14)
-- #####################################################################

ALTER TABLE TBL_PRODUKT ENABLE CONSTRAINT FK_PROD_PROD_GRUPPE;

-- #####################################################################
--  KAP3: Demo 10 (Seite 14)
-- #####################################################################

ALTER TABLE TBL_KUNDE ADD (TEST  VARCHAR2(10) DEFAULT 'n/a' NOT NULL);

-- #####################################################################
--  KAP3: Demo 11 (Seite 14)
-- #####################################################################

ALTER TABLE TBL_KUNDE MODIFY (TEST NUMBER DEFAULT -1);

-- #####################################################################
--  KAP3: Demo 12 (Seite 15)
-- #####################################################################

INSERT INTO TBL_KUNDE 
VALUES (1, 'Horst', 'Huber', 'Karolinenweg 11a', '20357', 'Hamburg', 'M', to_date('01.05.1947', 'DD.MM.YYYY'), null);

COMMIT;

-- #####################################################################
--  KAP3: Demo 13 (Seite 15)
-- #####################################################################

INSERT INTO TBL_KUNDE (KUNDE_NR, VORNAME, NACHNAME)
VALUES (2, 'Erika', 'Schmidt');

INSERT INTO TBL_KUNDE (KUNDE_NR, VORNAME, NACHNAME)
VALUES (3, 'Bert', 'Mller');

COMMIT;

-- #####################################################################
--  KAP3: Demo 14 (Seite 16)
-- #####################################################################

UPDATE TBL_KUNDE
SET Strasse='Goethestrasse 5', PLZ='22512', Ort='Hamburg'
WHERE KUNDE_NR=2;

UPDATE TBL_KUNDE
SET Strasse='Schwedenweg 22', PLZ='22123', Ort='Hamburg'
WHERE KUNDE_NR=3;

COMMIT;

-- #####################################################################
--  KAP3: Demo 15 (Seite 16)
-- #####################################################################

ALTER TABLE TBL_PRODUKT ADD (PREIS_NEU NUMBER);

UPDATE TBL_PRODUKT
SET PREIS_NEU=PREIS*5;

COMMIT;

SELECT *
FROM TBL_PRODUKT;

-- #####################################################################
--  KAP3: Demo 16 (Seite 16)
-- #####################################################################

DELETE TBL_KUNDE
WHERE KUNDE_NR=2;

COMMIT;

SELECT *
FROM TBL_KUNDE

-- #####################################################################
--  KAP3: Demo 17 (Seite 17)
-- #####################################################################

ALTER TABLE TBL_BESTELLUNG DISABLE CONSTRAINT FK_BESTELLUNG_KUNDE;

TRUNCATE TABLE TBL_KUNDE;

ALTER TABLE TBL_BESTELLUNG ENABLE CONSTRAINT FK_BESTELLUNG_KUNDE;

SELECT *
FROM TBL_KUNDE;
