-- #####################################################################
--  KAP5: bung 1
-- #####################################################################

SELECT DISTINCT k.KUNDE_NR, k.VORNAME, k.NACHNAME
FROM TBL_KUNDE k
  JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
WHERE to_char(BESTELL_DATUM, 'YYYYMM')='201302'

-- #####################################################################
--  KAP5: bung 2
-- #####################################################################

SELECT DISTINCT m.*
FROM TBL_BESTELLUNG b
  JOIN TBL_KUNDE k ON b.KUNDE_NR=k.KUNDE_NR
  JOIN TBL_MITARBEITER m ON b.FAHRER_NR=m.MITARBEITER_NR
WHERE k.NACHNAME='Mller'
AND to_char(BESTELL_DATUM, 'YYYYMM')='201304'

-- #####################################################################
--  KAP5: bung 3
-- #####################################################################

SELECT DISTINCT p.PRODUKT_NR, p.BEZEICHNUNG
FROM TBL_KUNDE k
  JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
WHERE to_number(to_char(BESTELL_DATUM, 'MM')) between 4 and 6
AND k.ORT='Kiel'
ORDER BY 1

-- #####################################################################
--  KAP5: bung 4
-- #####################################################################

SELECT *
FROM TBL_PRODUKT p
  LEFT JOIN TBL_BESTELLUNG_POS bp ON p.PRODUKT_NR=bp.PRODUKT_NR
WHERE bp.PRODUKT_NR IS NULL

-- #####################################################################
--  KAP5: Aufgabe 1
-- #####################################################################

SELECT DISTINCT k.KUNDE_NR, k.VORNAME, k.NACHNAME, m.MITARBEITER_NR, m.NACHNAME||', '||m.VORNAME AS FAHRER_NAME
FROM TBL_KUNDE k
  JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
  JOIN TBL_MITARBEITER m ON b.FAHRER_NR=m.MITARBEITER_NR
WHERE to_char(b.BESTELL_DATUM,'YYYYMM')='201304'
ORDER BY 1,4

-- #####################################################################
--  KAP5: Aufgabe 2
-- #####################################################################

SELECT DISTINCT p.PRODUKT_NR, p.BEZEICHNUNG
FROM TBL_KUNDE k
  JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
WHERE k.NACHNAME='Maier'
AND to_char(b.BESTELL_DATUM,'YYYYMM')='201304'
ORDER BY 1


-- #####################################################################
--  KAP5: Aufgabe 3
-- #####################################################################

SELECT DISTINCT k.KUNDE_NR, k.VORNAME, k.NACHNAME
FROM TBL_KUNDE k
  JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
WHERE k.ORT='Hamburg'
AND to_char(b.BESTELL_DATUM,'YYYYMM')='201302'
AND p.BEZEICHNUNG='Rumpsteak'
ORDER BY 1


-- #####################################################################
--  KAP5: Aufgabe 4
-- #####################################################################

SELECT DISTINCT m.MITARBEITER_NR, m.VORNAME, m.NACHNAME, m.TYP, b.FAHRER_NR
FROM TBL_MITARBEITER m
  LEFT JOIN TBL_BESTELLUNG b ON b.FAHRER_NR=m.MITARBEITER_NR
WHERE FAHRER_NR IS NULL

--> Nur die Fahrer haben schon was ausgeliefert.

-- #####################################################################
--  KAP5: Aufgabe 5
-- #####################################################################

SELECT DISTINCT b.BESTELLUNG_NR
FROM TBL_BESTELLUNG b
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
  JOIN TBL_PRODUKTGRUPPE pg ON p.PRODUKT_GRUPPE_NR=pg.PRODUKT_GRUPPE_NR
WHERE pg.BEZEICHNUNG='Fleischgerichte'
ORDER BY 1

