-- #####################################################################
--  KAP7: bung 1
-- #####################################################################

SELECT  kunde.*,
        ort.ORT_UMSATZ,
        round(kunde.KUNDE_UMSATZ/ort.ORT_UMSATZ*100,1) AS ANTEIL
FROM (
        SELECT  k.KUNDE_NR,
                VORNAME||' '||NACHNAME AS KUNDE_NAME,
                k.ORT,
                SUM(bp.ANZAHL*p.PREIS) AS KUNDE_UMSATZ
        FROM TBL_KUNDE k
          JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
          JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
          JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
        GROUP BY k.KUNDE_NR, VORNAME, NACHNAME, k.ORT
      ) kunde
JOIN (
        SELECT  k.ORT,
                SUM(bp.ANZAHL*p.PREIS) AS ORT_UMSATZ
        FROM TBL_KUNDE k
          JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
          JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
          JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
        GROUP BY k.ORT
      ) ort
ON kunde.ORT=ort.ORT
ORDER BY 3,1;

-- #####################################################################
--  KAP7: bung 2
-- #####################################################################

select  prod.produkt_nr,
        prod.bezeichnung as PROD_BEZEICHNUNG,
        grp_preis_avg.bezeichnung as GRP_BEZEICHNUNG,
        prod.preis,
        grp_preis_avg.avg_preis
from
(
    select grp.produkt_gruppe_nr, grp.bezeichnung, round(avg(p.preis),2) aS AVG_PREIS
    from tbl_produktgruppe grp
      join tbl_produkt p on grp.produkt_gruppe_nr=p.produkt_gruppe_nr
    group by grp.produkt_gruppe_nr, grp.bezeichnung
) grp_preis_avg
join tbl_produkt prod on grp_preis_avg.produkt_gruppe_nr=prod.produkt_gruppe_nr
where prod.preis>grp_preis_avg.avg_preis
order by 1;

-- #####################################################################
--  KAP7: bung 3
-- #####################################################################

SELECT  distinct bp.BESTELLUNG_NR
FROM TBL_BESTELLUNG_POS bp 
WHERE PRODUKT_NR IN (
      
      SELECT  DISTINCT PRODUKT_NR
      FROM TBL_PRODUKT p
      WHERE PREIS>8
);

-- #####################################################################
--  KAP7: bung 4
-- #####################################################################

SELECT  distinct b.*
FROM TBL_BESTELLUNG b
  JOIN TBL_BESTELLUNG_POS bpos ON b.BESTELLUNG_NR=bpos.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bpos.PRODUKT_NR=p.PRODUKT_NR
WHERE p.PRODUKT_GRUPPE_NR IN (
      
      SELECT  PRODUKT_GRUPPE_NR
      FROM TBL_PRODUKT p
      GROUP BY PRODUKT_GRUPPE_NR
      HAVING AVG(PREIS)>6
);

-- #####################################################################
--  KAP7: bung 5
-- #####################################################################

SELECT *
FROM TBL_MITARBEITER
WHERE GEHALT < 0.75*(
  SELECT AVG(GEHALT)
  FROM TBL_MITARBEITER
);

-- #####################################################################
--  KAP7: bung 6
-- #####################################################################

SELECT *
FROM TBL_MITARBEITER m_main
WHERE GEHALT>(
    SELECT AVG(GEHALT)
    FROM TBL_MITARBEITER m_sub
    WHERE m_sub.TYP=m_main.TYP
)

-- #####################################################################
--  KAP7: bung 7
-- #####################################################################

CREATE TABLE TBL_PROV_VERKAEUFER(
    VERKAEUFER_NR NUMBER(10),
    MONAT NUMBER(6),
    UMSATZ NUMBER(10,2),
    PROVISION NUMBER(10,2)
);

INSERT INTO TBL_PROV_VERKAEUFER (VERKAEUFER_NR, MONAT, UMSATZ)
SELECT  b.VERKAEUFER_NR,
        TO_NUMBER(TO_CHAR(BESTELL_DATUM,'YYYYMM')) AS MONAT,
        SUM(bpos.ANZAHL*p.PREIS) AS UMSATZ
FROM TBL_BESTELLUNG b
  JOIN TBL_BESTELLUNG_POS bpos ON b.BESTELLUNG_NR=bpos.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bpos.PRODUKT_NR=p.PRODUKT_NR
GROUP BY  b.VERKAEUFER_NR,
          TO_NUMBER(TO_CHAR(BESTELL_DATUM,'YYYYMM'));
          
COMMIT; 

UPDATE TBL_PROV_VERKAEUFER prov
SET PROVISION=prov.UMSATZ*(
    SELECT PROV_SATZ
    FROM TBL_MITARBEITER m
    WHERE m.MITARBEITER_NR=prov.VERKAEUFER_NR
);

COMMIT;

-- #####################################################################
--  KAP7: Aufgabe 1
-- #####################################################################

SELECT AVG(UMSATZ) AS AVG_UMSATZ
FROM (
    SELECT  b.BESTELLUNG_NR,
            SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
    FROM TBL_BESTELLUNG b
      JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
      JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
    GROUP BY b.BESTELLUNG_NR
);

--> Ergebnis als SubQuery in 2. Abfrage verwenden:

SELECT  b.BESTELLUNG_NR,
        SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
FROM TBL_BESTELLUNG b
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR 
GROUP BY b.BESTELLUNG_NR
HAVING SUM(bp.ANZAHL*p.PREIS)>(
    SELECT AVG(UMSATZ) AS AVG_UMSATZ
    FROM (
        SELECT  b.BESTELLUNG_NR,
                SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
        FROM TBL_BESTELLUNG b
          JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
          JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
        GROUP BY b.BESTELLUNG_NR
    )
);

-- #####################################################################
--  KAP7: Aufgabe 2
-- #####################################################################

Select  BESTELL_DATUM,
        SUM(bp.ANZAHL*p.PREIS) AS UMSATZ,
        MAX(ums_pro_mon.UMSATZ) AS UMSATZ_PRO_MONAT
from TBL_BESTELLUNG b
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
  JOIN (

    Select  TO_CHAR(BESTELL_DATUM,'YYYYMM') AS MONAT,
            SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
    from TBL_BESTELLUNG b
        JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
        JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
    WHERE BESTELL_DATUM BETWEEN TO_DATE('01.01.2013', 'DD.MM.YYYY') AND TO_DATE('31.03.2013', 'DD.MM.YYYY')
    GROUP BY TO_CHAR(BESTELL_DATUM,'YYYYMM')
    
  ) ums_pro_mon ON ums_pro_mon.MONAT=to_char(b.BESTELL_DATUM,'YYYYMM')
WHERE BESTELL_DATUM BETWEEN TO_DATE('01.01.2013', 'DD.MM.YYYY') AND TO_DATE('31.03.2013', 'DD.MM.YYYY')
GROUP BY BESTELL_DATUM
ORDER BY BESTELL_DATUM;



-- #####################################################################
--  KAP7: Aufgabe 3
-- #####################################################################

SELECT  a.*,
        b.*,
        round(a.UMSATZ/b.GESAMT_UMSATZ,2) AS ANTEIL
FROM
(
    SELECT  k.ORT,
            SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
    FROM TBL_KUNDE k
      JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
      JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
      JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
    GROUP BY k.ORT
) a,
(
    SELECT SUM(bp.ANZAHL*p.PREIS) AS GESAMT_UMSATZ
    FROM TBL_BESTELLUNG_POS bp
      JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
) b;

-- #####################################################################
--  KAP7: Aufgabe 4
-- #####################################################################

SELECT *
FROM TBL_PRODUKTGRUPPE
WHERE PRODUKT_GRUPPE_NR NOT IN(
    SELECT DISTINCT p.PRODUKT_GRUPPE_NR
    FROM TBL_BESTELLUNG_POS bp
      JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
);

-- #####################################################################
--  KAP7: Aufgabe 5
-- #####################################################################

SELECT x.*
FROM (
    SELECT  k.KUNDE_NR,
            k.VORNAME,
            k.NACHNAME,
            SUM(bp.ANZAHL*p.PREIS) AS UMSATZ_KUNDE
    FROM TBL_KUNDE k
          JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
          JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
          JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
    GROUP BY k.KUNDE_NR,
            k.VORNAME,
            k.NACHNAME
) x
WHERE x.UMSATZ_KUNDE>0.66*
  (
    SELECT UMSATZ_KUNDE
    FROM (
        SELECT  k.KUNDE_NR,
                SUM(bp.ANZAHL*p.PREIS) AS UMSATZ_KUNDE
        FROM TBL_KUNDE k
              JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
              JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
              JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
        GROUP BY k.KUNDE_NR
        ORDER BY 2 DESC
    )
    WHERE ROWNUM=1
  )
ORDER BY 1;


-- #####################################################################
--  KAP7: Aufgabe 6a
-- #####################################################################

CREATE TABLE TBL_PRODUKT_TEST AS
SELECT * FROM TBL_PRODUKT WHERE 1=2;

INSERT INTO TBL_PRODUKT_TEST
SELECT *
FROM TBL_PRODUKT
WHERE PREIS>( SELECT AVG(PREIS) FROM TBL_PRODUKT);

COMMIT;

-- #####################################################################
--  KAP7: Aufgabe 6b
-- #####################################################################

ALTER TABLE TBL_PRODUKT_TEST ADD(AVG_PREIS_GRUPPE NUMBER(10,2));

UPDATE TBL_PRODUKT_TEST p
SET AVG_PREIS_GRUPPE= (
    SELECT AVG(PREIS) 
    FROM TBL_PRODUKT p2
    WHERE p2.PRODUKT_GRUPPE_NR=p.PRODUKT_GRUPPE_NR
    );
    
COMMIT; 

-- #####################################################################
--  KAP7: Aufgabe 7
-- #####################################################################

SELECT x.*
from
(
    SELECT  p.PRODUKT_NR,
            p.BEZEICHNUNG,
            SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
    FROM TBL_BESTELLUNG_POS bp
      JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
    GROUP BY p.PRODUKT_NR,
            p.BEZEICHNUNG
    ORDER BY 3 DESC
) x
where rownum<=3;


-- #####################################################################
--  KAP7: Aufgabe 8
-- #####################################################################

SELECT  a.*,
        (a.BEST_MAI/a.BEST_APRIL-1)*100 AS ABWEICHUNG
FROM (
    SELECT  m.VORNAME,
            m.NACHNAME,
            COUNT(DISTINCT b_april.BESTELLUNG_NR) AS BEST_APRIL,
            COUNT(DISTINCT b_mai.BESTELLUNG_NR) AS BEST_MAI
    FROM TBL_MITARBEITER m
      JOIN TBL_BESTELLUNG b_april ON b_april.FAHRER_NR=m.MITARBEITER_NR
      JOIN TBL_BESTELLUNG b_mai ON b_mai.FAHRER_NR=m.MITARBEITER_NR
    WHERE to_char(b_april.BESTELL_DATUM,'YYYYMM')='201304'
    AND to_char(b_mai.BESTELL_DATUM,'YYYYMM')='201305'
    GROUP BY m.VORNAME,
            m.NACHNAME
) a;


-- #####################################################################
--  KAP7: Aufgabe 9
-- #####################################################################

SELECT DISTINCT ORT, PRODUKT_NR, BEZEICHNUNG
FROM TBL_KUNDE kunde_main, TBL_PRODUKT
WHERE PRODUKT_NR IN(
          SELECT x.PRODUKT_NR
          FROM(
              SELECT  k.ORT,
                      p.PRODUKT_NR,
                      p.BEZEICHNUNG,
                      SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
              FROM TBL_KUNDE k
                JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
                JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
                JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
              GROUP BY  k.ORT,
                        p.PRODUKT_NR,
                        p.BEZEICHNUNG
              ORDER BY 1,4 ASC
          ) x
          WHERE ROWNUM=1
          AND x.ORT=kunde_main.ORT        
)
ORDER BY 1,2;

